#include <assert.h>
#include "HashTable.h"


// Return the linked list containing one or more items
LinkedList const & HashTable::FindList( const char* str ) const
{
	int h = hash( str );
	return list[ h ];
}


// Hashing function to convert string into integer index
int HashTable::hash( const char* str ) const
{
	assert( str != NULL && str[ 0 ] != NULL );

	unsigned h = str[ 0 ];

	for ( int i = 1; str[ i ] != NULL; ++i )
	{
		h = (h << 4) + str[ i ];
	}

	// Return remainder
	return h % TableSize;
}


// Add new items
void HashTable::Add( const char* str, int id )
{
	int h = hash( str );
	list[ h ].Add( str, id );
}


// Return the value we are looking for that is 
// contained in the linked list
bool HashTable::Get( const char* str, int& value )
{
	bool found = false;
	LinkedList* list = (LinkedList*) &FindList( str );

	Node const * n = list->Find( str );

	if ( n != NULL )
	{
		value = n->Value();
		found = true;
	}

	return found;
}