#include "List.h"
#include <string.h>

// Destructor
LinkedList::~LinkedList()
{
	// Tidy up
	while ( head != 0 )
	{
		Node* pNode = head;
		head = head->Next();
		delete pNode;
	}
}


void LinkedList::Add( const char* str, int v )
{
	// Add to front of the linked list
	Node* pNode = new Node( head, str, v );
	head = pNode;
}


// Find item in linked list that matches key
Node const * LinkedList::Find( const char* str )
{
	for ( Node const * n = GetHead();
		  n != NULL;
		  n = n->Next() )
	{
		if ( !strcmp( n->Key(), str ) )
		{
			return n;
		}
	}

	return NULL;
}